// Add HTML compression !!!
// Javascript Cruncher
// Copyright (c) 2002 by Charles Foster, cfoster.net
//
// Removes all unnecessary spaces, tabs, comments etc
//
// Feel free to use and modify this source and application
// in anyway you like (at your own risk of course) :)

/*
	Modified by Jean-Charles Meyrignac October 2002

	+ blank lines removed
	+ \n skipped when encountering ',' at the end of the line
	+ in a string removed \ at when end of the line
	+ end of lines not any more skipped, since ; may be missing
	+ handle "<!-- garbage"
	+ handle "//garbage-->"
	+ transform {\n to {
	+ transform \n{ to {
	+ transform }\n to }
	+ transform \n} to }

	- improved keywords detection

	- converting ";;" to ";" bugs when "for(;;)"
	- removing ; before the end of the line may add bugs in the cases: for(); or while();

  to do:
	- "a"+"b" -> "ab"
	- "a" + \n "b" -> "ab"

*/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define NB_KEYWORDS		5
static char *keywords[NB_KEYWORDS] = {"var","new","throw","typeof","case"};

// ------
static int isRkey(char* b)
{
	int z;
	for (z=0;z < NB_KEYWORDS;++z)
	{
		int n;
		n = strlen(keywords[z]);
		if (!memcmp(b, keywords[z], n))
		{
			if (b[n]==' '||b[n]==10||b[n]==13||b[n]==9)
			{
				return 1;
			}
		}
	}
	return 0;
}
// ------

int main(int args, char** argv)
{
	char *buffer;
	char *t_buffer;
	char *p, *q;
	int js_body=1;					// In main JS execution (no text or comments)
	int js_comment_block=0;			// inside /* */
	int js_comment=0;				// everything after the // on that line
	int js_double=0;				// inside "" - Exceptions: \"
	int js_single=0;				// inside '' - Exceptions: \'
	//int js_regexp=0;				// inside /REGEXP/ - Exceptions: \/
	int js_space=0;					// for when a space is needed
	int js_else=0;					// after else flag
	int js_function=0;				// after function flag
	int js_arg=0;					// after break or return flag
	int infile_size;				// misc bits and pieces
	FILE *infile;
	FILE *outfile;

	if (args != 3)
	{
		printf("Javascript Cruncher Copyright (c) 2002 Charles Foster\n"
					 "usage: js infile outfile\n");
		return 0;
	}
	if (strcmp(argv[1],argv[2]) == 0)
	{
		printf("I don't want you to over-write your existing js file\n");
		return 1;
	}
	if ((infile = fopen(argv[1],"rb")) == 0)
	{
		printf("%s doesn't exist\n",argv[1]);
		return 1;
	}

	if (!strcmp(argv[1]+strlen(argv[1])-3, ".js"))
	{
		js_body = 1;
	}
	else
	{
		js_body = 2;
	}


	fseek(infile,0,SEEK_END);
	infile_size = ftell(infile);
	rewind(infile);
	buffer = (char*)malloc(infile_size);
	if (buffer == NULL)
	{
		printf("Out of memory\n");
		return 1;
	}
	fread(buffer, infile_size, 1, infile);
	t_buffer = (char*)malloc(infile_size);
	if (t_buffer == NULL)
	{
		printf("Out of memory\n");
		return 1;
	}

	p = buffer;
	q = t_buffer;
	while(p < buffer+infile_size)
	{
		printf("%d\r", p-buffer);
		//if (p-buffer==1952) _asm int 3;
		//if (memcmp(p, "if ", 3) == 0) _asm int 3;
		if (js_body == 2)
		{
			// HTML code
			if (!memicmp(p, "<script", 7))
			{
				js_body = 1;
				// copy until '>'
				while(p < buffer+infile_size)
				{
					char c;
					c = *p++;
					*q++=c;
					if (c == '>')
					{
						break;
					}
				}
			}
			else
			{
				*q++=*p++;
			}
		}
		else if (js_body)
		{
			if (!memicmp(p, "</script", 8))
			{
				*q++ = *p++;
				js_body = 2;
			}
			else if (p[0] == '/' && p[1] == '/')
			{
				js_body=0; js_comment=1;
				p+=2;
			}
			else if (!memcmp(p, "<!--", 4))
			{
				js_body=0;js_comment=1;
				memcpy(q, "<!--\n", 5);
				q+=5;
				p+=4;
			}
			else if (p[0] == '/' && p[1] == '*')
			{
				js_body=0; js_comment_block=1;
				p+=2;
			}
			/*else if (p[0]==';' && p[1]==';')
			{
				// ;; -> ;
				++p;
			}*/
			/*else if (p[0] == '/')
			{
				*q++ = *p++;
				js_body=0; js_regexp=1;
			}*/
			else if (p[0] == '"')
			{
				*q++ = *p++;
				js_body=0; js_double=1;
				js_arg=0;
			}
			else if (p[0] == '\'')
			{
				*q++ = *p++;
				js_body=0; js_single=1;				
			}
			else if (isRkey(p))
			{
				*q++ = *p++;
				js_space=1;
			}
			/*else if (memcmp(p,"instanceof",10) == 0)
			{
				_asm int 3;
				*q++ = ' ';
				*q++ = *p++;
				js_space=1;
			}*/
			else if (memcmp(p,"function",8) == 0)
			{
				*q++ = *p++;
				js_space=1;
				js_function=1;
			}
			else if (memcmp(p,"else",4) == 0)
			{
				memcpy(q,p,4);
				p+=4;q+=4;
				js_else=1;
			}
			else if (memcmp(p,"return",6) == 0)
			{
				memcpy(q,p,6);
				p+=6;q+=6;
				js_arg=1;
			}
			else if (memcmp(p,"break",5) == 0)
			{
				memcpy(q,p,5);
				p+=5;q+=5;
				//js_arg=1;
			}
			else if (p[0] != ' ' && p[0] != 9 && p[0] != 10 && p[0]!=13)
			{
				if (js_else && p[0] != '{')
				{
					*q++ = ' ';
				}
				else if (js_arg && p[0] != ';' && p[0] != '[' && p[0] != '}' && p[0]!='(')
				{
					// return or break;
					if (p[0] < '0' || (p[0] > '9' && p[0] < 'A') || (p[0] > 'Z' && p[0] < 'a') || p[0] > 'z')
					{
						if (p[0]!='{')
						{
							//_asm int 3;
							printf("Internal error 1\n");
							return 1;
						}
					}
					if(p[0]!='{')
					{
						*q++ = ' ';
					}
					//js_arg = 0;
				}
				else if (js_function && p[0] == '(')
				{
					js_space=0;
				}
				js_else=0;
				js_arg=0;
				if (p[0] == '{' || p[0] == '}')
				{
					if (q > t_buffer)
					{
						if (q[-1] == 10)
						{
							--q;
						}
					}
				}
				*q++ = *p++;
			}
			else if ((p[0] == ' '||p[0]==9) && js_space && !js_function)
			{
				*q++ = ' ';
				++p;
				js_space=0;
			}
			else if ((p[0] == ' '||p[0]==9) && js_space && js_function)
			{
				if (p[1] >= 'A' && p[1] <= 'Z' || p[1] >= 'a' && p[1] <= 'z' || p[1] == '_')
				{
					*q++ = ' ';
					++p;
					js_function=0;
					js_space=0;
				}
				else
				{
					++p;
					js_function=0;
					js_space=0;
				}
			}
			else if (p[0] == 10)
			{
				js_arg = 0;
				js_else = 0;
				if (q > t_buffer)
				{
					// we can safely remove blank lines or ; or last space at the end of the line
					if (q[-1]==10 || q[-1]==';' || q[-1]==' ')
					{
						--q;
					}
					if (q[-1]==',' || q[-1]=='{' || q[-1]=='}')
					{
						++p;
						continue;
					}
				}
				// remove first \n
				if (q != t_buffer)
				{
					*q++ = *p;
				}
				++p;
			}
			else if (p[0]==13 || p[0]==' ' || p[0]==9)
			{
				// we skip the byte
				++p;
			}
			else
			{
				printf("Internal error 2\n");
				return 1;
				// skip the byte !!!
				//_asm int 3;
				//++p;
			}
		} // !js_body:
		else
		{
			if (js_comment)
			{
				if (!memcmp(p, "-->", 3))
				{
					memcpy(q, "//-->\n", 6);
					q+=6;
				}
				else if (p[0] == '\n')
				{
					js_comment=0;
					js_body=1;
				}
				++p;
			}
			else if (js_comment_block)
			{
				if (p[0] == '*' && p[1] == '/')
				{
					js_comment_block=0;
					js_body=1;
					++p;
				}
				++p;
			}
			/*else if (js_regexp)
			{
				if (p[0] == '/' && p[-1] != '\\')
				{
					js_body=1;
					js_regexp=0;
				}
				*q++ = *p++;
			}*/
			else if (js_double)
			{
				if (p[0] == '\\' && p[1] == 13 && p[2] == 10)
				{
					p+=3;
					continue;
				}
				if (p[0] == '\\' && p[1] == 10)
				{
					p+=2;
					continue;
				}
				if (p[0] == '"' && p[-1] != '\\')
				{
					js_body=1;
					js_double=0;
				}
				*q++ = *p++;
			}
			else if (js_single)
			{
				if (p[0] == '\\' && p[1] == 13 && p[2] == 10)
				{
					p+=3;
					continue;
				}
				if (p[0] == '\\' && p[1] == 10)
				{
					p+=2;
					continue;
				}
				if (p[0] == '\'' && p[-1] != '\\')
				{
					js_body=1;
					js_single=0;
				}
				*q++ = *p++;
			}
			else
			{
				printf("Internal error 3\n");
				return 1;
				/*++p;
				_asm int 3;*/
			}
		}
	}
	if ((outfile = fopen(argv[2],"wb")) == 0)
	{
		printf("can't write to %s",argv[2]);
		return 1;
	}
	fwrite(t_buffer, q-t_buffer, 1, outfile);
	fclose(infile);
	fclose(outfile);
	return 0;
}
